import 'package:code_builder/code_builder.dart';
import 'package:dash_deck/builders/emitter.dart';
import 'package:dash_deck/builders/library_builder.dart';
import 'package:dash_deck/builders/widget_builder.dart';
import 'package:dash_deck/helpers/constants.dart';
import 'package:dash_deck/showtime.dart';

Future<void> buildCodePreviewBuilder(List<SlideData> slides) async {
  List<Class> widgets = [];

  for (var slide in slides) {
    if (slide.options.codePreview) {
      for (var snippet in slide.snippets) {
        final widget = statelessWidgetBuilder(
          slide,
          snippet.widgetName,
          snippet.source,
        );
        widgets.add(widget);
      }
    }
  }

  final library = libraryBuilder(
    widgets,
    directives: [
      Directive.import('package:flutter/material.dart'),
      Directive.import('package:mix/mix.dart'),
    ],
  );

  final codePreviewFile = kShowtimeDirectory.codePreviewFile;

  await runCodeEmitter(library, codePreviewFile);
}
