import 'dart:io';

import 'package:path/path.dart';

class Constants {
  static final workingDirectory = Directory.current.path;
  static const String presentationFileName = 'slides.md';
  static const String codePreviewFileName = 'code_preview.g.dart';
  static const String slidesFileName = 'slides.g.dart';
}

ShowtimeDirectory kShowtimeDirectory = ShowtimeDirectory();

class ShowtimeDirectory {
  late Directory _rootDir;

  ShowtimeDirectory({String? customDirectory}) {
    final path = customDirectory ?? join('lib', 'showtime');
    _rootDir = Directory(join(Constants.workingDirectory, path));
  }

  String get rootPath => _rootDir.path;

  File get presentationFile {
    return File(join(rootPath, Constants.presentationFileName));
  }

  File get codePreviewFile {
    return File(join(rootPath, Constants.codePreviewFileName));
  }

  File get slidesFile {
    return File(join(rootPath, Constants.slidesFileName));
  }
}
