import 'package:dash_deck/builders/code_preview_builder.dart';
import 'package:dash_deck/builders/slide_data_builder.dart';
import 'package:dash_deck/helpers/constants.dart';
import 'package:dash_deck/helpers/slides_parser.dart';
import 'package:dash_deck/models/slide_data.model.dart';

Future<List<SlideData>> loadSlide() async {
  final presentationFile = kShowtimeDirectory.presentationFile;

  final presentationContent = await presentationFile.readAsString();
  final slideContents = slideMarkdownParser(presentationContent);

  await buildSlideData(slideContents);
  await buildCodePreviewBuilder(slideContents);

  return slideContents;
}
